// Code generated by SQLBoiler 4.14.2 (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package models

import (
	"context"
	"database/sql"
	"fmt"
	"reflect"
	"strconv"
	"strings"
	"sync"
	"time"

	"github.com/friendsofgo/errors"
	"github.com/volatiletech/null/v8"
	"github.com/volatiletech/sqlboiler/v4/boil"
	"github.com/volatiletech/sqlboiler/v4/queries"
	"github.com/volatiletech/sqlboiler/v4/queries/qm"
	"github.com/volatiletech/sqlboiler/v4/queries/qmhelper"
	"github.com/volatiletech/strmangle"
)

// CategoryPercent is an object representing the database table.
type CategoryPercent struct {
	PercentID int          `boil:"percent_id" json:"percent_id" toml:"percent_id" yaml:"percent_id"`
	Percent   null.Float64 `boil:"percent" json:"percent,omitempty" toml:"percent" yaml:"percent,omitempty"`
	CreatedAt time.Time    `boil:"created_at" json:"created_at" toml:"created_at" yaml:"created_at"`
	UpdatedAt time.Time    `boil:"updated_at" json:"updated_at" toml:"updated_at" yaml:"updated_at"`

	R *categoryPercentR `boil:"-" json:"-" toml:"-" yaml:"-"`
	L categoryPercentL  `boil:"-" json:"-" toml:"-" yaml:"-"`
}

var CategoryPercentColumns = struct {
	PercentID string
	Percent   string
	CreatedAt string
	UpdatedAt string
}{
	PercentID: "percent_id",
	Percent:   "percent",
	CreatedAt: "created_at",
	UpdatedAt: "updated_at",
}

var CategoryPercentTableColumns = struct {
	PercentID string
	Percent   string
	CreatedAt string
	UpdatedAt string
}{
	PercentID: "category_percent.percent_id",
	Percent:   "category_percent.percent",
	CreatedAt: "category_percent.created_at",
	UpdatedAt: "category_percent.updated_at",
}

// Generated where

type whereHelpernull_Float64 struct{ field string }

func (w whereHelpernull_Float64) EQ(x null.Float64) qm.QueryMod {
	return qmhelper.WhereNullEQ(w.field, false, x)
}
func (w whereHelpernull_Float64) NEQ(x null.Float64) qm.QueryMod {
	return qmhelper.WhereNullEQ(w.field, true, x)
}
func (w whereHelpernull_Float64) LT(x null.Float64) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.LT, x)
}
func (w whereHelpernull_Float64) LTE(x null.Float64) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.LTE, x)
}
func (w whereHelpernull_Float64) GT(x null.Float64) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.GT, x)
}
func (w whereHelpernull_Float64) GTE(x null.Float64) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.GTE, x)
}
func (w whereHelpernull_Float64) IN(slice []float64) qm.QueryMod {
	values := make([]interface{}, 0, len(slice))
	for _, value := range slice {
		values = append(values, value)
	}
	return qm.WhereIn(fmt.Sprintf("%s IN ?", w.field), values...)
}
func (w whereHelpernull_Float64) NIN(slice []float64) qm.QueryMod {
	values := make([]interface{}, 0, len(slice))
	for _, value := range slice {
		values = append(values, value)
	}
	return qm.WhereNotIn(fmt.Sprintf("%s NOT IN ?", w.field), values...)
}

func (w whereHelpernull_Float64) IsNull() qm.QueryMod    { return qmhelper.WhereIsNull(w.field) }
func (w whereHelpernull_Float64) IsNotNull() qm.QueryMod { return qmhelper.WhereIsNotNull(w.field) }

var CategoryPercentWhere = struct {
	PercentID whereHelperint
	Percent   whereHelpernull_Float64
	CreatedAt whereHelpertime_Time
	UpdatedAt whereHelpertime_Time
}{
	PercentID: whereHelperint{field: "\"category_percent\".\"percent_id\""},
	Percent:   whereHelpernull_Float64{field: "\"category_percent\".\"percent\""},
	CreatedAt: whereHelpertime_Time{field: "\"category_percent\".\"created_at\""},
	UpdatedAt: whereHelpertime_Time{field: "\"category_percent\".\"updated_at\""},
}

// CategoryPercentRels is where relationship names are stored.
var CategoryPercentRels = struct {
	PercentOrderGoals    string
	PercentOrderVehicles string
}{
	PercentOrderGoals:    "PercentOrderGoals",
	PercentOrderVehicles: "PercentOrderVehicles",
}

// categoryPercentR is where relationships are stored.
type categoryPercentR struct {
	PercentOrderGoals    OrderGoalSlice    `boil:"PercentOrderGoals" json:"PercentOrderGoals" toml:"PercentOrderGoals" yaml:"PercentOrderGoals"`
	PercentOrderVehicles OrderVehicleSlice `boil:"PercentOrderVehicles" json:"PercentOrderVehicles" toml:"PercentOrderVehicles" yaml:"PercentOrderVehicles"`
}

// NewStruct creates a new relationship struct
func (*categoryPercentR) NewStruct() *categoryPercentR {
	return &categoryPercentR{}
}

func (r *categoryPercentR) GetPercentOrderGoals() OrderGoalSlice {
	if r == nil {
		return nil
	}
	return r.PercentOrderGoals
}

func (r *categoryPercentR) GetPercentOrderVehicles() OrderVehicleSlice {
	if r == nil {
		return nil
	}
	return r.PercentOrderVehicles
}

// categoryPercentL is where Load methods for each relationship are stored.
type categoryPercentL struct{}

var (
	categoryPercentAllColumns            = []string{"percent_id", "percent", "created_at", "updated_at"}
	categoryPercentColumnsWithoutDefault = []string{}
	categoryPercentColumnsWithDefault    = []string{"percent_id", "percent", "created_at", "updated_at"}
	categoryPercentPrimaryKeyColumns     = []string{"percent_id"}
	categoryPercentGeneratedColumns      = []string{}
)

type (
	// CategoryPercentSlice is an alias for a slice of pointers to CategoryPercent.
	// This should almost always be used instead of []CategoryPercent.
	CategoryPercentSlice []*CategoryPercent
	// CategoryPercentHook is the signature for custom CategoryPercent hook methods
	CategoryPercentHook func(context.Context, boil.ContextExecutor, *CategoryPercent) error

	categoryPercentQuery struct {
		*queries.Query
	}
)

// Cache for insert, update and upsert
var (
	categoryPercentType                 = reflect.TypeOf(&CategoryPercent{})
	categoryPercentMapping              = queries.MakeStructMapping(categoryPercentType)
	categoryPercentPrimaryKeyMapping, _ = queries.BindMapping(categoryPercentType, categoryPercentMapping, categoryPercentPrimaryKeyColumns)
	categoryPercentInsertCacheMut       sync.RWMutex
	categoryPercentInsertCache          = make(map[string]insertCache)
	categoryPercentUpdateCacheMut       sync.RWMutex
	categoryPercentUpdateCache          = make(map[string]updateCache)
	categoryPercentUpsertCacheMut       sync.RWMutex
	categoryPercentUpsertCache          = make(map[string]insertCache)
)

var (
	// Force time package dependency for automated UpdatedAt/CreatedAt.
	_ = time.Second
	// Force qmhelper dependency for where clause generation (which doesn't
	// always happen)
	_ = qmhelper.Where
)

var categoryPercentAfterSelectHooks []CategoryPercentHook

var categoryPercentBeforeInsertHooks []CategoryPercentHook
var categoryPercentAfterInsertHooks []CategoryPercentHook

var categoryPercentBeforeUpdateHooks []CategoryPercentHook
var categoryPercentAfterUpdateHooks []CategoryPercentHook

var categoryPercentBeforeDeleteHooks []CategoryPercentHook
var categoryPercentAfterDeleteHooks []CategoryPercentHook

var categoryPercentBeforeUpsertHooks []CategoryPercentHook
var categoryPercentAfterUpsertHooks []CategoryPercentHook

// doAfterSelectHooks executes all "after Select" hooks.
func (o *CategoryPercent) doAfterSelectHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range categoryPercentAfterSelectHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeInsertHooks executes all "before insert" hooks.
func (o *CategoryPercent) doBeforeInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range categoryPercentBeforeInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterInsertHooks executes all "after Insert" hooks.
func (o *CategoryPercent) doAfterInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range categoryPercentAfterInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpdateHooks executes all "before Update" hooks.
func (o *CategoryPercent) doBeforeUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range categoryPercentBeforeUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpdateHooks executes all "after Update" hooks.
func (o *CategoryPercent) doAfterUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range categoryPercentAfterUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeDeleteHooks executes all "before Delete" hooks.
func (o *CategoryPercent) doBeforeDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range categoryPercentBeforeDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterDeleteHooks executes all "after Delete" hooks.
func (o *CategoryPercent) doAfterDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range categoryPercentAfterDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpsertHooks executes all "before Upsert" hooks.
func (o *CategoryPercent) doBeforeUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range categoryPercentBeforeUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpsertHooks executes all "after Upsert" hooks.
func (o *CategoryPercent) doAfterUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range categoryPercentAfterUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// AddCategoryPercentHook registers your hook function for all future operations.
func AddCategoryPercentHook(hookPoint boil.HookPoint, categoryPercentHook CategoryPercentHook) {
	switch hookPoint {
	case boil.AfterSelectHook:
		categoryPercentAfterSelectHooks = append(categoryPercentAfterSelectHooks, categoryPercentHook)
	case boil.BeforeInsertHook:
		categoryPercentBeforeInsertHooks = append(categoryPercentBeforeInsertHooks, categoryPercentHook)
	case boil.AfterInsertHook:
		categoryPercentAfterInsertHooks = append(categoryPercentAfterInsertHooks, categoryPercentHook)
	case boil.BeforeUpdateHook:
		categoryPercentBeforeUpdateHooks = append(categoryPercentBeforeUpdateHooks, categoryPercentHook)
	case boil.AfterUpdateHook:
		categoryPercentAfterUpdateHooks = append(categoryPercentAfterUpdateHooks, categoryPercentHook)
	case boil.BeforeDeleteHook:
		categoryPercentBeforeDeleteHooks = append(categoryPercentBeforeDeleteHooks, categoryPercentHook)
	case boil.AfterDeleteHook:
		categoryPercentAfterDeleteHooks = append(categoryPercentAfterDeleteHooks, categoryPercentHook)
	case boil.BeforeUpsertHook:
		categoryPercentBeforeUpsertHooks = append(categoryPercentBeforeUpsertHooks, categoryPercentHook)
	case boil.AfterUpsertHook:
		categoryPercentAfterUpsertHooks = append(categoryPercentAfterUpsertHooks, categoryPercentHook)
	}
}

// One returns a single categoryPercent record from the query.
func (q categoryPercentQuery) One(ctx context.Context, exec boil.ContextExecutor) (*CategoryPercent, error) {
	o := &CategoryPercent{}

	queries.SetLimit(q.Query, 1)

	err := q.Bind(ctx, exec, o)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: failed to execute a one query for category_percent")
	}

	if err := o.doAfterSelectHooks(ctx, exec); err != nil {
		return o, err
	}

	return o, nil
}

// All returns all CategoryPercent records from the query.
func (q categoryPercentQuery) All(ctx context.Context, exec boil.ContextExecutor) (CategoryPercentSlice, error) {
	var o []*CategoryPercent

	err := q.Bind(ctx, exec, &o)
	if err != nil {
		return nil, errors.Wrap(err, "models: failed to assign all query results to CategoryPercent slice")
	}

	if len(categoryPercentAfterSelectHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterSelectHooks(ctx, exec); err != nil {
				return o, err
			}
		}
	}

	return o, nil
}

// Count returns the count of all CategoryPercent records in the query.
func (q categoryPercentQuery) Count(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to count category_percent rows")
	}

	return count, nil
}

// Exists checks if the row exists in the table.
func (q categoryPercentQuery) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)
	queries.SetLimit(q.Query, 1)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return false, errors.Wrap(err, "models: failed to check if category_percent exists")
	}

	return count > 0, nil
}

// PercentOrderGoals retrieves all the order_goal's OrderGoals with an executor via percent column.
func (o *CategoryPercent) PercentOrderGoals(mods ...qm.QueryMod) orderGoalQuery {
	var queryMods []qm.QueryMod
	if len(mods) != 0 {
		queryMods = append(queryMods, mods...)
	}

	queryMods = append(queryMods,
		qm.Where("\"order_goal\".\"percent\"=?", o.PercentID),
	)

	return OrderGoals(queryMods...)
}

// PercentOrderVehicles retrieves all the order_vehicle's OrderVehicles with an executor via percent column.
func (o *CategoryPercent) PercentOrderVehicles(mods ...qm.QueryMod) orderVehicleQuery {
	var queryMods []qm.QueryMod
	if len(mods) != 0 {
		queryMods = append(queryMods, mods...)
	}

	queryMods = append(queryMods,
		qm.Where("\"order_vehicle\".\"percent\"=?", o.PercentID),
	)

	return OrderVehicles(queryMods...)
}

// LoadPercentOrderGoals allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for a 1-M or N-M relationship.
func (categoryPercentL) LoadPercentOrderGoals(ctx context.Context, e boil.ContextExecutor, singular bool, maybeCategoryPercent interface{}, mods queries.Applicator) error {
	var slice []*CategoryPercent
	var object *CategoryPercent

	if singular {
		var ok bool
		object, ok = maybeCategoryPercent.(*CategoryPercent)
		if !ok {
			object = new(CategoryPercent)
			ok = queries.SetFromEmbeddedStruct(&object, &maybeCategoryPercent)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", object, maybeCategoryPercent))
			}
		}
	} else {
		s, ok := maybeCategoryPercent.(*[]*CategoryPercent)
		if ok {
			slice = *s
		} else {
			ok = queries.SetFromEmbeddedStruct(&slice, maybeCategoryPercent)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", slice, maybeCategoryPercent))
			}
		}
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &categoryPercentR{}
		}
		args = append(args, object.PercentID)
	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &categoryPercentR{}
			}

			for _, a := range args {
				if queries.Equal(a, obj.PercentID) {
					continue Outer
				}
			}

			args = append(args, obj.PercentID)
		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(
		qm.From(`order_goal`),
		qm.WhereIn(`order_goal.percent in ?`, args...),
	)
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load order_goal")
	}

	var resultSlice []*OrderGoal
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice order_goal")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results in eager load on order_goal")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for order_goal")
	}

	if len(orderGoalAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}
	if singular {
		object.R.PercentOrderGoals = resultSlice
		for _, foreign := range resultSlice {
			if foreign.R == nil {
				foreign.R = &orderGoalR{}
			}
			foreign.R.PercentCategoryPercent = object
		}
		return nil
	}

	for _, foreign := range resultSlice {
		for _, local := range slice {
			if queries.Equal(local.PercentID, foreign.Percent) {
				local.R.PercentOrderGoals = append(local.R.PercentOrderGoals, foreign)
				if foreign.R == nil {
					foreign.R = &orderGoalR{}
				}
				foreign.R.PercentCategoryPercent = local
				break
			}
		}
	}

	return nil
}

// LoadPercentOrderVehicles allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for a 1-M or N-M relationship.
func (categoryPercentL) LoadPercentOrderVehicles(ctx context.Context, e boil.ContextExecutor, singular bool, maybeCategoryPercent interface{}, mods queries.Applicator) error {
	var slice []*CategoryPercent
	var object *CategoryPercent

	if singular {
		var ok bool
		object, ok = maybeCategoryPercent.(*CategoryPercent)
		if !ok {
			object = new(CategoryPercent)
			ok = queries.SetFromEmbeddedStruct(&object, &maybeCategoryPercent)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", object, maybeCategoryPercent))
			}
		}
	} else {
		s, ok := maybeCategoryPercent.(*[]*CategoryPercent)
		if ok {
			slice = *s
		} else {
			ok = queries.SetFromEmbeddedStruct(&slice, maybeCategoryPercent)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", slice, maybeCategoryPercent))
			}
		}
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &categoryPercentR{}
		}
		args = append(args, object.PercentID)
	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &categoryPercentR{}
			}

			for _, a := range args {
				if queries.Equal(a, obj.PercentID) {
					continue Outer
				}
			}

			args = append(args, obj.PercentID)
		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(
		qm.From(`order_vehicle`),
		qm.WhereIn(`order_vehicle.percent in ?`, args...),
	)
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load order_vehicle")
	}

	var resultSlice []*OrderVehicle
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice order_vehicle")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results in eager load on order_vehicle")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for order_vehicle")
	}

	if len(orderVehicleAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}
	if singular {
		object.R.PercentOrderVehicles = resultSlice
		for _, foreign := range resultSlice {
			if foreign.R == nil {
				foreign.R = &orderVehicleR{}
			}
			foreign.R.PercentCategoryPercent = object
		}
		return nil
	}

	for _, foreign := range resultSlice {
		for _, local := range slice {
			if queries.Equal(local.PercentID, foreign.Percent) {
				local.R.PercentOrderVehicles = append(local.R.PercentOrderVehicles, foreign)
				if foreign.R == nil {
					foreign.R = &orderVehicleR{}
				}
				foreign.R.PercentCategoryPercent = local
				break
			}
		}
	}

	return nil
}

// AddPercentOrderGoals adds the given related objects to the existing relationships
// of the category_percent, optionally inserting them as new records.
// Appends related to o.R.PercentOrderGoals.
// Sets related.R.PercentCategoryPercent appropriately.
func (o *CategoryPercent) AddPercentOrderGoals(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*OrderGoal) error {
	var err error
	for _, rel := range related {
		if insert {
			queries.Assign(&rel.Percent, o.PercentID)
			if err = rel.Insert(ctx, exec, boil.Infer()); err != nil {
				return errors.Wrap(err, "failed to insert into foreign table")
			}
		} else {
			updateQuery := fmt.Sprintf(
				"UPDATE \"order_goal\" SET %s WHERE %s",
				strmangle.SetParamNames("\"", "\"", 1, []string{"percent"}),
				strmangle.WhereClause("\"", "\"", 2, orderGoalPrimaryKeyColumns),
			)
			values := []interface{}{o.PercentID, rel.ID}

			if boil.IsDebug(ctx) {
				writer := boil.DebugWriterFrom(ctx)
				fmt.Fprintln(writer, updateQuery)
				fmt.Fprintln(writer, values)
			}
			if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
				return errors.Wrap(err, "failed to update foreign table")
			}

			queries.Assign(&rel.Percent, o.PercentID)
		}
	}

	if o.R == nil {
		o.R = &categoryPercentR{
			PercentOrderGoals: related,
		}
	} else {
		o.R.PercentOrderGoals = append(o.R.PercentOrderGoals, related...)
	}

	for _, rel := range related {
		if rel.R == nil {
			rel.R = &orderGoalR{
				PercentCategoryPercent: o,
			}
		} else {
			rel.R.PercentCategoryPercent = o
		}
	}
	return nil
}

// SetPercentOrderGoals removes all previously related items of the
// category_percent replacing them completely with the passed
// in related items, optionally inserting them as new records.
// Sets o.R.PercentCategoryPercent's PercentOrderGoals accordingly.
// Replaces o.R.PercentOrderGoals with related.
// Sets related.R.PercentCategoryPercent's PercentOrderGoals accordingly.
func (o *CategoryPercent) SetPercentOrderGoals(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*OrderGoal) error {
	query := "update \"order_goal\" set \"percent\" = null where \"percent\" = $1"
	values := []interface{}{o.PercentID}
	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, query)
		fmt.Fprintln(writer, values)
	}
	_, err := exec.ExecContext(ctx, query, values...)
	if err != nil {
		return errors.Wrap(err, "failed to remove relationships before set")
	}

	if o.R != nil {
		for _, rel := range o.R.PercentOrderGoals {
			queries.SetScanner(&rel.Percent, nil)
			if rel.R == nil {
				continue
			}

			rel.R.PercentCategoryPercent = nil
		}
		o.R.PercentOrderGoals = nil
	}

	return o.AddPercentOrderGoals(ctx, exec, insert, related...)
}

// RemovePercentOrderGoals relationships from objects passed in.
// Removes related items from R.PercentOrderGoals (uses pointer comparison, removal does not keep order)
// Sets related.R.PercentCategoryPercent.
func (o *CategoryPercent) RemovePercentOrderGoals(ctx context.Context, exec boil.ContextExecutor, related ...*OrderGoal) error {
	if len(related) == 0 {
		return nil
	}

	var err error
	for _, rel := range related {
		queries.SetScanner(&rel.Percent, nil)
		if rel.R != nil {
			rel.R.PercentCategoryPercent = nil
		}
		if _, err = rel.Update(ctx, exec, boil.Whitelist("percent")); err != nil {
			return err
		}
	}
	if o.R == nil {
		return nil
	}

	for _, rel := range related {
		for i, ri := range o.R.PercentOrderGoals {
			if rel != ri {
				continue
			}

			ln := len(o.R.PercentOrderGoals)
			if ln > 1 && i < ln-1 {
				o.R.PercentOrderGoals[i] = o.R.PercentOrderGoals[ln-1]
			}
			o.R.PercentOrderGoals = o.R.PercentOrderGoals[:ln-1]
			break
		}
	}

	return nil
}

// AddPercentOrderVehicles adds the given related objects to the existing relationships
// of the category_percent, optionally inserting them as new records.
// Appends related to o.R.PercentOrderVehicles.
// Sets related.R.PercentCategoryPercent appropriately.
func (o *CategoryPercent) AddPercentOrderVehicles(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*OrderVehicle) error {
	var err error
	for _, rel := range related {
		if insert {
			queries.Assign(&rel.Percent, o.PercentID)
			if err = rel.Insert(ctx, exec, boil.Infer()); err != nil {
				return errors.Wrap(err, "failed to insert into foreign table")
			}
		} else {
			updateQuery := fmt.Sprintf(
				"UPDATE \"order_vehicle\" SET %s WHERE %s",
				strmangle.SetParamNames("\"", "\"", 1, []string{"percent"}),
				strmangle.WhereClause("\"", "\"", 2, orderVehiclePrimaryKeyColumns),
			)
			values := []interface{}{o.PercentID, rel.ID}

			if boil.IsDebug(ctx) {
				writer := boil.DebugWriterFrom(ctx)
				fmt.Fprintln(writer, updateQuery)
				fmt.Fprintln(writer, values)
			}
			if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
				return errors.Wrap(err, "failed to update foreign table")
			}

			queries.Assign(&rel.Percent, o.PercentID)
		}
	}

	if o.R == nil {
		o.R = &categoryPercentR{
			PercentOrderVehicles: related,
		}
	} else {
		o.R.PercentOrderVehicles = append(o.R.PercentOrderVehicles, related...)
	}

	for _, rel := range related {
		if rel.R == nil {
			rel.R = &orderVehicleR{
				PercentCategoryPercent: o,
			}
		} else {
			rel.R.PercentCategoryPercent = o
		}
	}
	return nil
}

// SetPercentOrderVehicles removes all previously related items of the
// category_percent replacing them completely with the passed
// in related items, optionally inserting them as new records.
// Sets o.R.PercentCategoryPercent's PercentOrderVehicles accordingly.
// Replaces o.R.PercentOrderVehicles with related.
// Sets related.R.PercentCategoryPercent's PercentOrderVehicles accordingly.
func (o *CategoryPercent) SetPercentOrderVehicles(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*OrderVehicle) error {
	query := "update \"order_vehicle\" set \"percent\" = null where \"percent\" = $1"
	values := []interface{}{o.PercentID}
	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, query)
		fmt.Fprintln(writer, values)
	}
	_, err := exec.ExecContext(ctx, query, values...)
	if err != nil {
		return errors.Wrap(err, "failed to remove relationships before set")
	}

	if o.R != nil {
		for _, rel := range o.R.PercentOrderVehicles {
			queries.SetScanner(&rel.Percent, nil)
			if rel.R == nil {
				continue
			}

			rel.R.PercentCategoryPercent = nil
		}
		o.R.PercentOrderVehicles = nil
	}

	return o.AddPercentOrderVehicles(ctx, exec, insert, related...)
}

// RemovePercentOrderVehicles relationships from objects passed in.
// Removes related items from R.PercentOrderVehicles (uses pointer comparison, removal does not keep order)
// Sets related.R.PercentCategoryPercent.
func (o *CategoryPercent) RemovePercentOrderVehicles(ctx context.Context, exec boil.ContextExecutor, related ...*OrderVehicle) error {
	if len(related) == 0 {
		return nil
	}

	var err error
	for _, rel := range related {
		queries.SetScanner(&rel.Percent, nil)
		if rel.R != nil {
			rel.R.PercentCategoryPercent = nil
		}
		if _, err = rel.Update(ctx, exec, boil.Whitelist("percent")); err != nil {
			return err
		}
	}
	if o.R == nil {
		return nil
	}

	for _, rel := range related {
		for i, ri := range o.R.PercentOrderVehicles {
			if rel != ri {
				continue
			}

			ln := len(o.R.PercentOrderVehicles)
			if ln > 1 && i < ln-1 {
				o.R.PercentOrderVehicles[i] = o.R.PercentOrderVehicles[ln-1]
			}
			o.R.PercentOrderVehicles = o.R.PercentOrderVehicles[:ln-1]
			break
		}
	}

	return nil
}

// CategoryPercents retrieves all the records using an executor.
func CategoryPercents(mods ...qm.QueryMod) categoryPercentQuery {
	mods = append(mods, qm.From("\"category_percent\""))
	q := NewQuery(mods...)
	if len(queries.GetSelect(q)) == 0 {
		queries.SetSelect(q, []string{"\"category_percent\".*"})
	}

	return categoryPercentQuery{q}
}

// FindCategoryPercent retrieves a single record by ID with an executor.
// If selectCols is empty Find will return all columns.
func FindCategoryPercent(ctx context.Context, exec boil.ContextExecutor, percentID int, selectCols ...string) (*CategoryPercent, error) {
	categoryPercentObj := &CategoryPercent{}

	sel := "*"
	if len(selectCols) > 0 {
		sel = strings.Join(strmangle.IdentQuoteSlice(dialect.LQ, dialect.RQ, selectCols), ",")
	}
	query := fmt.Sprintf(
		"select %s from \"category_percent\" where \"percent_id\"=$1", sel,
	)

	q := queries.Raw(query, percentID)

	err := q.Bind(ctx, exec, categoryPercentObj)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: unable to select from category_percent")
	}

	if err = categoryPercentObj.doAfterSelectHooks(ctx, exec); err != nil {
		return categoryPercentObj, err
	}

	return categoryPercentObj, nil
}

// Insert a single record using an executor.
// See boil.Columns.InsertColumnSet documentation to understand column list inference for inserts.
func (o *CategoryPercent) Insert(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) error {
	if o == nil {
		return errors.New("models: no category_percent provided for insertion")
	}

	var err error
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		if o.UpdatedAt.IsZero() {
			o.UpdatedAt = currTime
		}
	}

	if err := o.doBeforeInsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(categoryPercentColumnsWithDefault, o)

	key := makeCacheKey(columns, nzDefaults)
	categoryPercentInsertCacheMut.RLock()
	cache, cached := categoryPercentInsertCache[key]
	categoryPercentInsertCacheMut.RUnlock()

	if !cached {
		wl, returnColumns := columns.InsertColumnSet(
			categoryPercentAllColumns,
			categoryPercentColumnsWithDefault,
			categoryPercentColumnsWithoutDefault,
			nzDefaults,
		)

		cache.valueMapping, err = queries.BindMapping(categoryPercentType, categoryPercentMapping, wl)
		if err != nil {
			return err
		}
		cache.retMapping, err = queries.BindMapping(categoryPercentType, categoryPercentMapping, returnColumns)
		if err != nil {
			return err
		}
		if len(wl) != 0 {
			cache.query = fmt.Sprintf("INSERT INTO \"category_percent\" (\"%s\") %%sVALUES (%s)%%s", strings.Join(wl, "\",\""), strmangle.Placeholders(dialect.UseIndexPlaceholders, len(wl), 1, 1))
		} else {
			cache.query = "INSERT INTO \"category_percent\" %sDEFAULT VALUES%s"
		}

		var queryOutput, queryReturning string

		if len(cache.retMapping) != 0 {
			queryReturning = fmt.Sprintf(" RETURNING \"%s\"", strings.Join(returnColumns, "\",\""))
		}

		cache.query = fmt.Sprintf(cache.query, queryOutput, queryReturning)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}

	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(queries.PtrsFromMapping(value, cache.retMapping)...)
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}

	if err != nil {
		return errors.Wrap(err, "models: unable to insert into category_percent")
	}

	if !cached {
		categoryPercentInsertCacheMut.Lock()
		categoryPercentInsertCache[key] = cache
		categoryPercentInsertCacheMut.Unlock()
	}

	return o.doAfterInsertHooks(ctx, exec)
}

// Update uses an executor to update the CategoryPercent.
// See boil.Columns.UpdateColumnSet documentation to understand column list inference for updates.
// Update does not automatically update the record in case of default values. Use .Reload() to refresh the records.
func (o *CategoryPercent) Update(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) (int64, error) {
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		o.UpdatedAt = currTime
	}

	var err error
	if err = o.doBeforeUpdateHooks(ctx, exec); err != nil {
		return 0, err
	}
	key := makeCacheKey(columns, nil)
	categoryPercentUpdateCacheMut.RLock()
	cache, cached := categoryPercentUpdateCache[key]
	categoryPercentUpdateCacheMut.RUnlock()

	if !cached {
		wl := columns.UpdateColumnSet(
			categoryPercentAllColumns,
			categoryPercentPrimaryKeyColumns,
		)

		if !columns.IsWhitelist() {
			wl = strmangle.SetComplement(wl, []string{"created_at"})
		}
		if len(wl) == 0 {
			return 0, errors.New("models: unable to update category_percent, could not build whitelist")
		}

		cache.query = fmt.Sprintf("UPDATE \"category_percent\" SET %s WHERE %s",
			strmangle.SetParamNames("\"", "\"", 1, wl),
			strmangle.WhereClause("\"", "\"", len(wl)+1, categoryPercentPrimaryKeyColumns),
		)
		cache.valueMapping, err = queries.BindMapping(categoryPercentType, categoryPercentMapping, append(wl, categoryPercentPrimaryKeyColumns...))
		if err != nil {
			return 0, err
		}
	}

	values := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, values)
	}
	var result sql.Result
	result, err = exec.ExecContext(ctx, cache.query, values...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update category_percent row")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by update for category_percent")
	}

	if !cached {
		categoryPercentUpdateCacheMut.Lock()
		categoryPercentUpdateCache[key] = cache
		categoryPercentUpdateCacheMut.Unlock()
	}

	return rowsAff, o.doAfterUpdateHooks(ctx, exec)
}

// UpdateAll updates all rows with the specified column values.
func (q categoryPercentQuery) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	queries.SetUpdate(q.Query, cols)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all for category_percent")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected for category_percent")
	}

	return rowsAff, nil
}

// UpdateAll updates all rows with the specified column values, using an executor.
func (o CategoryPercentSlice) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	ln := int64(len(o))
	if ln == 0 {
		return 0, nil
	}

	if len(cols) == 0 {
		return 0, errors.New("models: update all requires at least one column argument")
	}

	colNames := make([]string, len(cols))
	args := make([]interface{}, len(cols))

	i := 0
	for name, value := range cols {
		colNames[i] = name
		args[i] = value
		i++
	}

	// Append all of the primary key values for each column
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), categoryPercentPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := fmt.Sprintf("UPDATE \"category_percent\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, colNames),
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), len(colNames)+1, categoryPercentPrimaryKeyColumns, len(o)))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all in categoryPercent slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected all in update all categoryPercent")
	}
	return rowsAff, nil
}

// Upsert attempts an insert using an executor, and does an update or ignore on conflict.
// See boil.Columns documentation for how to properly use updateColumns and insertColumns.
func (o *CategoryPercent) Upsert(ctx context.Context, exec boil.ContextExecutor, updateOnConflict bool, conflictColumns []string, updateColumns, insertColumns boil.Columns) error {
	if o == nil {
		return errors.New("models: no category_percent provided for upsert")
	}
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		o.UpdatedAt = currTime
	}

	if err := o.doBeforeUpsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(categoryPercentColumnsWithDefault, o)

	// Build cache key in-line uglily - mysql vs psql problems
	buf := strmangle.GetBuffer()
	if updateOnConflict {
		buf.WriteByte('t')
	} else {
		buf.WriteByte('f')
	}
	buf.WriteByte('.')
	for _, c := range conflictColumns {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(updateColumns.Kind))
	for _, c := range updateColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(insertColumns.Kind))
	for _, c := range insertColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	for _, c := range nzDefaults {
		buf.WriteString(c)
	}
	key := buf.String()
	strmangle.PutBuffer(buf)

	categoryPercentUpsertCacheMut.RLock()
	cache, cached := categoryPercentUpsertCache[key]
	categoryPercentUpsertCacheMut.RUnlock()

	var err error

	if !cached {
		insert, ret := insertColumns.InsertColumnSet(
			categoryPercentAllColumns,
			categoryPercentColumnsWithDefault,
			categoryPercentColumnsWithoutDefault,
			nzDefaults,
		)

		update := updateColumns.UpdateColumnSet(
			categoryPercentAllColumns,
			categoryPercentPrimaryKeyColumns,
		)

		if updateOnConflict && len(update) == 0 {
			return errors.New("models: unable to upsert category_percent, could not build update column list")
		}

		conflict := conflictColumns
		if len(conflict) == 0 {
			conflict = make([]string, len(categoryPercentPrimaryKeyColumns))
			copy(conflict, categoryPercentPrimaryKeyColumns)
		}
		cache.query = buildUpsertQueryPostgres(dialect, "\"category_percent\"", updateOnConflict, ret, update, conflict, insert)

		cache.valueMapping, err = queries.BindMapping(categoryPercentType, categoryPercentMapping, insert)
		if err != nil {
			return err
		}
		if len(ret) != 0 {
			cache.retMapping, err = queries.BindMapping(categoryPercentType, categoryPercentMapping, ret)
			if err != nil {
				return err
			}
		}
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)
	var returns []interface{}
	if len(cache.retMapping) != 0 {
		returns = queries.PtrsFromMapping(value, cache.retMapping)
	}

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}
	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(returns...)
		if errors.Is(err, sql.ErrNoRows) {
			err = nil // Postgres doesn't return anything when there's no update
		}
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}
	if err != nil {
		return errors.Wrap(err, "models: unable to upsert category_percent")
	}

	if !cached {
		categoryPercentUpsertCacheMut.Lock()
		categoryPercentUpsertCache[key] = cache
		categoryPercentUpsertCacheMut.Unlock()
	}

	return o.doAfterUpsertHooks(ctx, exec)
}

// Delete deletes a single CategoryPercent record with an executor.
// Delete will match against the primary key column to find the record to delete.
func (o *CategoryPercent) Delete(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if o == nil {
		return 0, errors.New("models: no CategoryPercent provided for delete")
	}

	if err := o.doBeforeDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	args := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), categoryPercentPrimaryKeyMapping)
	sql := "DELETE FROM \"category_percent\" WHERE \"percent_id\"=$1"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete from category_percent")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by delete for category_percent")
	}

	if err := o.doAfterDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	return rowsAff, nil
}

// DeleteAll deletes all matching rows.
func (q categoryPercentQuery) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if q.Query == nil {
		return 0, errors.New("models: no categoryPercentQuery provided for delete all")
	}

	queries.SetDelete(q.Query)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from category_percent")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for category_percent")
	}

	return rowsAff, nil
}

// DeleteAll deletes all rows in the slice, using an executor.
func (o CategoryPercentSlice) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if len(o) == 0 {
		return 0, nil
	}

	if len(categoryPercentBeforeDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doBeforeDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	var args []interface{}
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), categoryPercentPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "DELETE FROM \"category_percent\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, categoryPercentPrimaryKeyColumns, len(o))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from categoryPercent slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for category_percent")
	}

	if len(categoryPercentAfterDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	return rowsAff, nil
}

// Reload refetches the object from the database
// using the primary keys with an executor.
func (o *CategoryPercent) Reload(ctx context.Context, exec boil.ContextExecutor) error {
	ret, err := FindCategoryPercent(ctx, exec, o.PercentID)
	if err != nil {
		return err
	}

	*o = *ret
	return nil
}

// ReloadAll refetches every row with matching primary key column values
// and overwrites the original object slice with the newly updated slice.
func (o *CategoryPercentSlice) ReloadAll(ctx context.Context, exec boil.ContextExecutor) error {
	if o == nil || len(*o) == 0 {
		return nil
	}

	slice := CategoryPercentSlice{}
	var args []interface{}
	for _, obj := range *o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), categoryPercentPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "SELECT \"category_percent\".* FROM \"category_percent\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, categoryPercentPrimaryKeyColumns, len(*o))

	q := queries.Raw(sql, args...)

	err := q.Bind(ctx, exec, &slice)
	if err != nil {
		return errors.Wrap(err, "models: unable to reload all in CategoryPercentSlice")
	}

	*o = slice

	return nil
}

// CategoryPercentExists checks if the CategoryPercent row exists.
func CategoryPercentExists(ctx context.Context, exec boil.ContextExecutor, percentID int) (bool, error) {
	var exists bool
	sql := "select exists(select 1 from \"category_percent\" where \"percent_id\"=$1 limit 1)"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, percentID)
	}
	row := exec.QueryRowContext(ctx, sql, percentID)

	err := row.Scan(&exists)
	if err != nil {
		return false, errors.Wrap(err, "models: unable to check if category_percent exists")
	}

	return exists, nil
}

// Exists checks if the CategoryPercent row exists.
func (o *CategoryPercent) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	return CategoryPercentExists(ctx, exec, o.PercentID)
}
